summary refs log tree commit diff
path: root/catsit.sh
diff options
context:
space:
mode:
Diffstat (limited to 'catsit.sh')
-rw-r--r--catsit.sh34
1 files changed, 34 insertions, 0 deletions
diff --git a/catsit.sh b/catsit.sh
new file mode 100644
index 0000000..bc18a46
--- /dev/null
+++ b/catsit.sh
@@ -0,0 +1,34 @@
+#!/bin/sh
+set -eu
+
+die() {
+	echo "${0}:" "$@" >&2
+	exit 1
+}
+
+: ${CATSITD_PIPE:=/var/run/catsitd.pipe}
+
+while getopts 'c:' opt; do
+	case "${opt}" in
+		(c) CATSITD_PIPE=$OPTARG;;
+		(?) exit 1;;
+	esac
+done
+shift $((OPTIND - 1))
+
+if ! [ -p "${CATSITD_PIPE}" ]; then
+	die "${CATSITD_PIPE} is not a named pipe"
+fi
+
+[ $# -lt 1 ] && die 'action required'
+[ $# -lt 2 ] && die 'service name required'
+
+action=$(echo "${1}" | tr 'A-Z' 'a-z')
+for valid in start stop restart status $(kill -l | tr 'A-Z' 'a-z'); do
+	[ "${action}" = "${valid}" ] && break
+done
+if [ "${action}" != "${valid}" ]; then
+	die "${action} is not a valid action or signal"
+fi
+
+echo "$@" > "${CATSITD_PIPE}"